unit IndyTestForm;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, IdBaseComponent, IdComponent, IdTCPServer, IdEchoServer,
  QComCtrls;

type
  TForm1 = class(TForm)
    IdECHOServer1: TIdECHOServer;
    IdTCPServer1: TIdTCPServer;
    Memo1: TMemo;
    Edit1: TEdit;
    Button1: TButton;
    n1: TSpinEdit;
    PageControl1: TPageControl;
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
    procedure Button1Click(Sender: TObject);
    procedure IdTCPServer1Connect(AThread: TIdPeerThread);
    procedure IdTCPServer1Disconnect(AThread: TIdPeerThread);
  private
    { Private declarations }
    procedure WriteAllButThis(const s: string; AThread: TIdPeerThread);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.IdTCPServer1Execute(AThread: TIdPeerThread);
var s:string;
begin
  s := AThread.Connection.CurrentReadBuffer;
  Memo1.Lines.Add(s);
  WriteAllButThis(s,AThread);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  WriteAllButThis(Edit1.Text,nil);
end;

procedure TForm1.IdTCPServer1Connect(AThread: TIdPeerThread);
begin
  n1.Value := n1.Value + 1;
end;

procedure TForm1.IdTCPServer1Disconnect(AThread: TIdPeerThread);
begin
  n1.Value := n1.Value - 1;
end;

procedure TForm1.WriteAllButThis(const s:string;AThread: TIdPeerThread);
var i:integer; list : TList; t: TIdPeerThread;
begin
  try
    List := IdTCPServer1.Threads.LockList;
    for i:=0 to List.Count-1 do begin
      t := List[i];
      if ( t = AThread ) then continue;
      t.Connection.Write(s);
    end;
  finally
    IdTCPServer1.Threads.UnLockList;
  end;
end;


end.
