{------------------------------------------------------------------------------}
{
   Unit Name: tcpiptest
   Purpose  : Test program for TCP/IP-form
   Author   : Vesa Lappalainen
   Date     : 20.11.1999
   Changed  : 28.10.2001/vl
    + sending lf (\n) and carrige return (\n)

   ToDo     :

Kntmiseksi laita Search-path-kohtaan n:\kave\k2000\kcomp
(tavara lytyy mys http://www.mit.jyu.fi/~vesal/kave/k2000/kcomp/)
ja tuloshakemistot paikkaan, johon voit kirjoittaa.

Keskustelu toisen koneen kanssa:
================================
  1) Laita toisessa koneessa (tai jopa samassa) kuuntelemaan
     vaikkapa porttia 50000 (Listen)
  2) Ota toisella koneella yhteys porttiin 50000 (Connect)
     Laita kone kenttn koneen nimi tai ip-osoite (jos samassa koneessa
     haluat yhteyden, niin voit kytt koneen nime localhost).
  3) Lhet haluamasi teksti
  4) Lopuksi sammuta yhteys
  Samaan keskusteluun voi osallistua vaikka kuinka monta konetta, kunhan
  yksi on palvelin (kuuntelee) ja muut ottavat yhteyden siihen.

Yhteydenotto Telnetill
=======================
  1) Laita kuuntelemaan jotakin porttia (Listen)
  2) Ota yhteys toisesta koneesta (tai samasta) kirjoittamalla
      telnet koneennimi portin_numero
     Esim: telnet localhost 50000
  3) Kirjoita telnetiss
  4) Lhet tst ohjelmasta jonoja telnettiin


WWW-palvelin:
=============
  1) Laita kuuntelemaan porttia 80 (Listen)
  2) Ota selaimella yhteys koneeseen (vaikka samasta koneesta
     osoitteeseen: http://localhost/
  3) Lhet vastaukseksi jono:
      HTTP/1.1 200 OK\nContent-Type: text/html\n\nKissa puussa<br>istuu\n
  4) Sulje yhteys

WWW-asiakas:
============
  1) Ota yhteys porttiin 80 vaikkapa koneesseen www.mit.jyu.fi (Connect)
  2) Lhet jono: GET / HTTP/1.0\n\n



}
{------------------------------------------------------------------------------}

unit tcpiptest;

interface

uses
  SysUtils, Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QStdCtrls, QExtCtrls,
{$else}
  Windows, Messages,
  Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
{$endif}
  tcpipformIndy;

type
  TFormTestTCPIP = class(TForm)
    MemoLine: TMemo;
    PanelSend: TPanel;
    EditSend: TEdit;
    ButtonSend: TButton;
    ButtonTCPIP: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonSendClick(Sender: TObject);
    procedure ButtonTCPIPClick(Sender: TObject);
  private
    FormTCPIP:TFormTCPIP;
  public
    function OnGetInformation(const s:string):boolean; 
  end;

var
  FormTestTCPIP: TFormTestTCPIP;

implementation
uses kstring;

{$ifdef CLX}
{R *.xfm}
{$else}
{$R *.dfm}
{$endif}

procedure TFormTestTCPIP.FormCreate(Sender: TObject);
begin
  FormTCPIP := TFormTCPIP.Create(self);
  FormTCPIP.OnGetInformation := OnGetInformation;
end;

procedure TFormTestTCPIP.ButtonSendClick(Sender: TObject);
var s:string;
begin
  MemoLine.Lines.Add('> '+EditSend.Text);
  s := EditSend.Text;
  s := ChangeAll(s,'\n',#10);
  s := ChangeAll(s,'\r',#13);
  FormTCPIP.SendInformation(s);
  EditSend.SelectAll;
end;

function TFormTestTCPIP.OnGetInformation(const s: string): boolean;
begin
  MemoLine.Lines.Add('< '+s);
  Result := true;
end;

procedure TFormTestTCPIP.ButtonTCPIPClick(Sender: TObject);
begin
  FormTCPIP.Show;
end;

end.
